Debian Bug report logs - #392823
ITP: prayer -- fast IMAP-based web mail system with few dependencies

version graph

Package: wnpp; Maintainer for wnpp is wnpp@debian.org;

Reported by: Roderick Schertler <roderick@argon.org>

Date: Fri, 13 Oct 2006 19:18:50 UTC

Owned by: Magnus Holmgren <magnus@kibibyte.se>

Severity: wishlist

Fixed in version prayer/1.0.18-1

Done: Magnus Holmgren <magnus@kibibyte.se>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, roderick@argon.org, <wnpp@debian.org>:
Bug#392823; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Roderick Schertler <roderick@argon.org>:
New Bug report received and forwarded. Copy sent to roderick@argon.org, <wnpp@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Roderick Schertler <roderick@argon.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: RFP: prayer -- fast IMAP-based web mail system with few dependencies
Date: Fri, 13 Oct 2006 14:31:14 -0400
Package: wnpp
Severity: wishlist

* Package name    : prayer
  Version         : 1.0.18
  Upstream Author : David Carter <dpc22@cam.ac.uk>
* URL             : http://www-uxsup.csx.cam.ac.uk/~dpc22/prayer/
* License         : GPL
  Description     : IMAP-based web mail system

Prayer is an IMAP-based web mail system.  It is written in C and has
few dependencies.  In partiuclar, it doesn't require an HTTP server or
a database.  It doesn't use Javascript or frames, and doesn't require
cookies.

Here's the contents of the docs/FEATURES file:

$Cambridge: hermes/src/prayer/docs/FEATURES,v 1.1.1.1 2003/04/15 13:00:03 dpc22 Exp $

Performance/Scalability
=======================

Persistent Login Sessions:
  - (Multiple) persistent connections to IMAP and support servers.
  - Directory cache: single round trip to IMAP server for directory listing.
  - Works well with UW IMAP server (even using Unix format mail folders).

Written entirely in C as HTTP <--> IMAP Gateway. No scripting languages.
  - No discernible load on a Pentium III class system with 3,000 logins/day
  - Aggresive HTTP/1.0 and 1.1 connection caching to reduce SSL overhead.
  - Minimal use of fixed length buffers in C source code.

Single Webmail gateway can run on a number of small independant systems:
  Simple horizontal scalability if needed.

Simplicity
==========

Few external dependancies (Libraries: c-client, OpenSSL. Optional: cdb).
  - No external database: user preferences stored on IMAP server.
  - Single configuration file.

Doesn't use Javascript or Frames.
  - Runs quite happily with Netscape, Mozilla, IE, Lynx, Opera.
  - Text only mode for Lynx and w3m
  - Use of nested tables restricted to avoid confusing Lynx.

Doesn't need cookies:
  - Single optional cookie used to hide session-ID from browser URL display.

User Interface
==============

Message display:
  Hierachical listing of MIME BODYSTRUCTURE for display/download.
  User preferences to display TEXT/HTML inline with dangerous tags removed.
  Special handing for postponed message folder
  http:// and https:// in body converted into links.
  Message text wrapped to 80 columns (maintaining correct message quotation)
    - Colour codes for quoted message text

Mailbox list:
  Aggregate:  save, forward, (un)delete, (un)read. Zoom mode.
  Sort and Reverse Sort folder listing (on one of 7 criteria).
  Change to/Save marked messages to favourite Folder.

  Supports Persistent and non-persistent message marking (user preference):
    Non-persistent: normal Webmail behavior using HTML checkboxes:
       - Fewer page refreshes, no way to maintain state if links used
    Persistant:
       - Marks are HTML links, mark state recorded while stream open.

Seach (Message Headers/Text, Delivery Date, Status, Size).
  - Compound search on marked messages. 

Full Hierachical folder listing:
  - single level display with filters
  - Favourite/subscribed folders for shortcuts on list screen.
  - Transfer mailfolders to and from IMAP server using HTTP upload/download.

Compose:
  Local address lookup and Gecos expansion.
  Recursive Addressbook Lookup (with loop detection)
  Spell Check with Personal dictionary.
  Adaptive (and hopefully quite intellegent) line wrap algorithm
    - breaks message into "paragraph" blocks and wraps blocks independently.
  Undo. Roles. Rich headers.
  Alt-addresses list and local domain list used when constructing Cc list.
  Arbitary number of postponed messages using postponed messages folder

Personal Addressbook:
  Search. Import/Export local and remote pine .addressbook format files.
  Addressbook split into pages: can move to any page

Account managment using auxillary "accountd" server:
  - Change password and Gecos fields. Check disk quota.
  - Mail redirection, filtering and vacation messages using Exim filter files.

-- 
Roderick Schertler
roderick@argon.org



Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>:
Bug#392823; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Magnus Holmgren <holmgren@lysator.liu.se>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>. Full text and rfc822 format available.

Message #10 received at 392823@bugs.debian.org (full text, mbox):

From: Magnus Holmgren <holmgren@lysator.liu.se>
To: 392823@bugs.debian.org
Cc: control@bugs.debian.org, debian-devel@lists.debian.org
Subject: ITP: prayer -- fast IMAP-based web mail system with few dependencies
Date: Tue, 31 Oct 2006 11:16:16 +0200
[Message part 1 (text/plain, inline)]
retitle 392823 ITP: prayer -- fast IMAP-based web mail system with few dependencies
owner 392823 Magnus Holmgren <magnus@kibibyte.se>
thanks

I've sent some questions and comments upstream. Most notably, 

 * Prayer assumes that folders can't contain other folders, even if
   the IMAP server supports it. It appears that Dovecot with Maildir
   doesn't work very well with Prayer - all folders are treated as
   directories. Directories are containers for folders and other
   directories, but can't contain any mail. I don't know if this is
   an unavoidable problem with libc-client, or just a design mistake 
   in Prayer. Anyway Prayer probably works best with UW-imapd.

 * Currently, there is no IPv6 support. However, prayer-session uses
   libc-client to connect to the IMAP server, and IPv6 support can be
   acheived there by building with the version of libc-client currently
   in experimental.

 * The modified UTF-7 encoding isn't supported, which means that non-
   ASCII characters in folder names won't work.

-- 
Magnus Holmgren        holmgren@lysator.liu.se
                       (No Cc of list mail needed, thanks)
[Message part 2 (application/pgp-signature, inline)]

Changed Bug title. Request was from Magnus Holmgren <holmgren@lysator.liu.se> to control@bugs.debian.org. Full text and rfc822 format available.

Owner recorded as Magnus Holmgren <magnus@kibibyte.se>. Request was from Magnus Holmgren <holmgren@lysator.liu.se> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, Magnus Holmgren <magnus@kibibyte.se>:
Bug#392823; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Jonathan McDowell <noodles@earth.li>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, Magnus Holmgren <magnus@kibibyte.se>. Full text and rfc822 format available.

Message #19 received at 392823@bugs.debian.org (full text, mbox):

From: Jonathan McDowell <noodles@earth.li>
To: Magnus Holmgren <holmgren@lysator.liu.se>
Cc: 392823@bugs.debian.org
Subject: Re: ITP: prayer -- fast IMAP-based web mail system with few dependencies
Date: Tue, 31 Oct 2006 09:21:07 +0000
[Message part 1 (text/plain, inline)]
On Tue, Oct 31, 2006 at 11:16:16AM +0200, Magnus Holmgren wrote:
> retitle 392823 ITP: prayer -- fast IMAP-based web mail system with few dependencies
> owner 392823 Magnus Holmgren <magnus@kibibyte.se>
> thanks
> 
> I've sent some questions and comments upstream. Most notably, 
> 
>  * Prayer assumes that folders can't contain other folders, even if
>    the IMAP server supports it. It appears that Dovecot with Maildir
>    doesn't work very well with Prayer - all folders are treated as
>    directories. Directories are containers for folders and other
>    directories, but can't contain any mail. I don't know if this is
>    an unavoidable problem with libc-client, or just a design mistake 
>    in Prayer. Anyway Prayer probably works best with UW-imapd.

I hacked Prayer to work with Dovecot in a saner fashion; see:

http://www.earth.li/~noodles/blog/webmail-sucks.html

>  * Currently, there is no IPv6 support. However, prayer-session uses
>    libc-client to connect to the IMAP server, and IPv6 support can be
>    acheived there by building with the version of libc-client currently
>    in experimental.

Sweet.

J.

-- 
101 things you can't have too much  |       Black Cat Networks Ltd
      of : 18 - Roleplaying.        | http://www.blackcatnetworks.co.uk/
                                    |  UK Web, domain and email hosting
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, Magnus Holmgren <magnus@kibibyte.se>:
Bug#392823; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Magnus Holmgren <holmgren@lysator.liu.se>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, Magnus Holmgren <magnus@kibibyte.se>. Full text and rfc822 format available.

Message #24 received at 392823@bugs.debian.org (full text, mbox):

From: Magnus Holmgren <holmgren@lysator.liu.se>
To: Jonathan McDowell <noodles@earth.li>
Cc: 392823@bugs.debian.org
Subject: Re: ITP: prayer -- fast IMAP-based web mail system with few dependencies
Date: Tue, 31 Oct 2006 12:35:39 +0200
[Message part 1 (text/plain, inline)]
On Tuesday 31 October 2006 10:21, Jonathan McDowell wrote:
> I hacked Prayer to work with Dovecot in a saner fashion; see:
>
> http://www.earth.li/~noodles/blog/webmail-sucks.html

Interesting; thanks. A big step in the right direction, but still won't 
recognise folders with subfolders. I think I have to read the IMAP RFC 
thoroughly.

-- 
Magnus Holmgren        holmgren@lysator.liu.se
                       (No Cc of list mail needed, thanks)
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, Magnus Holmgren <magnus@kibibyte.se>:
Bug#392823; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Magnus Holmgren <holmgren@lysator.liu.se>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, Magnus Holmgren <magnus@kibibyte.se>. Full text and rfc822 format available.

Message #29 received at 392823@bugs.debian.org (full text, mbox):

From: Magnus Holmgren <holmgren@lysator.liu.se>
To: 392823@bugs.debian.org
Cc: debian-devel@lists.debian.org
Subject: RFC: ITP: prayer -- fast IMAP-based web mail system with few dependencies
Date: Thu, 9 Nov 2006 01:58:19 +0100
[Message part 1 (text/plain, inline)]
I have dug even deeper in the source code of Prayer, added IPv6 support, got a 
reply from upstream maintainer David Carter, and thought about it. The 
question is: Will the (additional) effort needed to produce and maintain a 
Debian package of good enough quality be worth it, considering the following?

1. Prayer is geared towards large-scale, perhaps even *very* large-scale 
installations. It offers speed and low resource usage at the expense of 
flexibility. Most admins probably will want to use an Apache-based package, 
such as Squirrelmail.

1a. About the flexibility: Changing the appearance is rather hard and, except 
for some colours, requires recompilation. Prayer produces HTML4 Transitional, 
full of <BODY color=... bgcolor=... >, <FONT> etc. It should preferably be 
changed to use CSS.

2. Support for other character sets than ISO-8859-1 is non-existant. 
Conversion of various mail text to UTF-8 has to be added.

3. Prayer isn't prepared for l10n. All UI strings have to be gone through and 
wrapped in gettext calls.

4. The code is a bit messy in the sense that there are many almost-similar 
variants of the same functions. It would do well with some restructuring.

5. At least minimal man pages have to be written.

6. And last but not least, Prayer is practically dead upstream. David Carter 
says that the purpose of Prayer was to fit on top of UW-based mail systems 
which really weren't designed to run Webmail. Now, after 5 years, they don't 
need it anymore. No more releases are planned.

To all this there is the problem with combined folders/directories already 
mentioned.

Comments are welcome, especially from the original requester. How many do you 
think will find Prayer useful?

(It's not that I want to give up, but it's a bit silly to maintain a package 
nobody uses.)

-- 
Magnus Holmgren        holmgren@lysator.liu.se
                       (No Cc of list mail needed, thanks)
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, Magnus Holmgren <magnus@kibibyte.se>:
Bug#392823; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Josselin Mouette <joss@debian.org>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, Magnus Holmgren <magnus@kibibyte.se>. Full text and rfc822 format available.

Message #34 received at 392823@bugs.debian.org (full text, mbox):

From: Josselin Mouette <joss@debian.org>
To: Magnus Holmgren <holmgren@lysator.liu.se>
Cc: 392823@bugs.debian.org, debian-devel@lists.debian.org
Subject: Re: RFC: ITP: prayer -- fast IMAP-based web mail system with few dependencies
Date: Fri, 10 Nov 2006 21:44:46 +0100
[Message part 1 (text/plain, inline)]
Le jeudi 09 novembre 2006 à 01:58 +0100, Magnus Holmgren a écrit :
> 1. Prayer is geared towards large-scale, perhaps even *very* large-scale 
> installations. It offers speed and low resource usage at the expense of 
> flexibility. Most admins probably will want to use an Apache-based package, 
> such as Squirrelmail.

Looks like an interesting feature.

> 2. Support for other character sets than ISO-8859-1 is non-existant. 
> Conversion of various mail text to UTF-8 has to be added.

Now *this* is the hard part. A modern MUA has to handle multiple
character sets, and this is far from easy to implement.

All the rest can be fixed with a reasonable (although far from
negligible) amount of work, but if it is to obtain a single-character
set application, I'm not sure it is that useful. Add to that the fact
that large installations want more and more to have some extras besides
the mail client, and you'll end up with few to zero installations.
-- 
Josselin Mouette                /\./\

"Do you have any more insane proposals for me?"
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, Magnus Holmgren <magnus@kibibyte.se>:
Bug#392823; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Magnus Holmgren <holmgren@lysator.liu.se>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, Magnus Holmgren <magnus@kibibyte.se>. Full text and rfc822 format available.

Message #39 received at 392823@bugs.debian.org (full text, mbox):

From: Magnus Holmgren <holmgren@lysator.liu.se>
To: debian-devel@lists.debian.org, debian-mentors@lists.debian.org
Cc: 392823@bugs.debian.org
Subject: RFC and preliminary RFS: prayer webmail
Date: Thu, 16 Nov 2006 02:54:08 +0100
[Message part 1 (text/plain, inline)]
I have now created a working prayer package. It's not finished, but good 
enough to show you, fellow list subscribers. You can find it at:

http://www.kibibyte.se/download/debian/

Please see the ITP at http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=392823 
for the full story.

The source package builds two packages: prayer and, for completeness, 
prayer-accountd, although the latter is still pretty useless outside 
Cambridge. Note: the prayer binary package uses libc-client2006b from 
experimental, but the dependency is missing from the control file. You will 
probably want to build the source package, after inspecting it, anyway.

> 2. Support for other character sets than ISO-8859-1 is non-existant.
> Conversion of various mail text to UTF-8 has to be added.

I have now addressed this as well as modified UTF-7 encoding and decoding. See 
README.Debian.

> 5. At least minimal man pages have to be written.

I have not addressed this yet. Please disregard for now.

Something I've been thinking about:

If two packages share a /var/(lib|run|log) subdirectory, how do you know when 
to remove it? I reckon that it should be removed when the last of the 
packages has been purged. Both packages place files there at runtime, so dpkg 
won't remove it since it's nonempty. But you can't just remove it in postrm 
if it's empty. Do you:

 a) leave it alone; let root delete it manually when it's no longer needed
 b) use dpkg -S to see if it's still in use
 c) use dpkg -l to see if the other package is still installed
 d) avoid sharing directories under /var
 e) do something else?

Thank you for your interest!

-- 
Magnus Holmgren        holmgren@lysator.liu.se
                       (No Cc of list mail needed, thanks)
[Message part 2 (application/pgp-signature, inline)]

Tags added: pending Request was from Anibal Monsalve Salazar <anibal@debian.org> to control@bugs.debian.org. (Sat, 24 Mar 2007 11:12:14 GMT) Full text and rfc822 format available.

Reply sent to Magnus Holmgren <magnus@kibibyte.se>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Roderick Schertler <roderick@argon.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #46 received at 392823-close@bugs.debian.org (full text, mbox):

From: Magnus Holmgren <magnus@kibibyte.se>
To: 392823-close@bugs.debian.org
Subject: Bug#392823: fixed in prayer 1.0.18-1
Date: Sun, 22 Apr 2007 16:29:50 +0000
Source: prayer
Source-Version: 1.0.18-1

We believe that the bug you reported is fixed in the latest version of
prayer, which is due to be installed in the Debian FTP archive:

prayer-accountd_1.0.18-1_i386.deb
  to pool/main/p/prayer/prayer-accountd_1.0.18-1_i386.deb
prayer_1.0.18-1.diff.gz
  to pool/main/p/prayer/prayer_1.0.18-1.diff.gz
prayer_1.0.18-1.dsc
  to pool/main/p/prayer/prayer_1.0.18-1.dsc
prayer_1.0.18-1_i386.deb
  to pool/main/p/prayer/prayer_1.0.18-1_i386.deb
prayer_1.0.18.orig.tar.gz
  to pool/main/p/prayer/prayer_1.0.18.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 392823@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Magnus Holmgren <magnus@kibibyte.se> (supplier of updated prayer package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Sat, 10 Mar 2007 14:24:21 +0100
Source: prayer
Binary: prayer prayer-accountd
Architecture: source i386
Version: 1.0.18-1
Distribution: experimental
Urgency: low
Maintainer: Amaya Rodrigo <amaya@debian.org>
Changed-By: Magnus Holmgren <magnus@kibibyte.se>
Description: 
 prayer     - Standalone IMAP-based webmail server
 prayer-accountd - account management daemon for Prayer
Closes: 392823
Changes: 
 prayer (1.0.18-1) experimental; urgency=low
 .
   * Initial release (Closes: #392823)
Files: 
 246ab9e6c43bc10cf1e217a3ac95cb5b 704 mail optional prayer_1.0.18-1.dsc
 405177f14ced9ef11969f4db2dd96c13 566168 mail optional prayer_1.0.18.orig.tar.gz
 d0de54aecdb4b9012c1d2bdfe724f02a 29574 mail optional prayer_1.0.18-1.diff.gz
 07ae0822540172805adad8e2b161ade0 516722 mail optional prayer_1.0.18-1_i386.deb
 dc4a3f93943b236b4fc87eb6c960efc6 89728 mail optional prayer-accountd_1.0.18-1_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)

iEYEARECAAYFAkYEaXcACgkQNFDtUT/MKpD55QCg8yKckLJLglg8TvVuney/A/gt
9OIAoKzdbcKDMGdf8ELuYdPxy4wPKP+l
=mGPL
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 17 Jun 2007 19:33:44 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 11:01:01 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.